Index: trunk/include/VBox/vmm/pgm.h
===================================================================
--- trunk/include/VBox/vmm/pgm.h	(revision 44346)
+++ trunk/include/VBox/vmm/pgm.h	(revision 44347)
@@ -469,6 +469,6 @@
 VMMR3DECL(int)      PGMR3PhysGetRange(PVM pVM, uint32_t iRange, PRTGCPHYS pGCPhysStart, PRTGCPHYS pGCPhysLast,
                                       const char **ppszDesc, bool *pfIsMmio);
-VMMR3DECL(int)      PGMR3QueryMemoryStats(PVM pVM, uint64_t *pcbTotalMem, uint64_t *pcbPrivateMem, uint64_t *pcbSharedMem, uint64_t *pcbZeroMem);
-VMMR3DECL(int)      PGMR3QueryGlobalMemoryStats(PVM pVM, uint64_t *pcbAllocMem, uint64_t *pcbFreeMem, uint64_t *pcbBallonedMem, uint64_t *pcbSharedMem);
+VMMR3DECL(int)      PGMR3QueryMemoryStats(PUVM pUVM, uint64_t *pcbTotalMem, uint64_t *pcbPrivateMem, uint64_t *pcbSharedMem, uint64_t *pcbZeroMem);
+VMMR3DECL(int)      PGMR3QueryGlobalMemoryStats(PUVM pUVM, uint64_t *pcbAllocMem, uint64_t *pcbFreeMem, uint64_t *pcbBallonedMem, uint64_t *pcbSharedMem);
 
 VMMR3DECL(int)      PGMR3PhysMMIORegister(PVM pVM, RTGCPHYS GCPhys, RTGCPHYS cb,
Index: trunk/include/VBox/vmm/ssm.h
===================================================================
--- trunk/include/VBox/vmm/ssm.h	(revision 44346)
+++ trunk/include/VBox/vmm/ssm.h	(revision 44347)
@@ -1144,5 +1144,5 @@
                                               PFNSSMINTSAVEPREP pfnSavePrep, PFNSSMINTSAVEEXEC pfnSaveExec, PFNSSMINTSAVEDONE pfnSaveDone,
                                               PFNSSMINTLOADPREP pfnLoadPrep, PFNSSMINTLOADEXEC pfnLoadExec, PFNSSMINTLOADDONE pfnLoadDone);
-VMMR3DECL(int)          SSMR3RegisterExternal(PVM pVM, const char *pszName, uint32_t uInstance, uint32_t uVersion, size_t cbGuess,
+VMMR3DECL(int)          SSMR3RegisterExternal(PUVM pUVM, const char *pszName, uint32_t uInstance, uint32_t uVersion, size_t cbGuess,
                                               PFNSSMEXTLIVEPREP pfnLivePrep, PFNSSMEXTLIVEEXEC pfnLiveExec, PFNSSMEXTLIVEVOTE pfnLiveVote,
                                               PFNSSMEXTSAVEPREP pfnSavePrep, PFNSSMEXTSAVEEXEC pfnSaveExec, PFNSSMEXTSAVEDONE pfnSaveDone,
@@ -1177,5 +1177,5 @@
 VMMR3_INT_DECL(int)     SSMR3HandleSetGCPtrSize(PSSMHANDLE pSSM, unsigned cbGCPtr);
 VMMR3DECL(void)         SSMR3HandleReportLivePercent(PSSMHANDLE pSSM, unsigned uPercent);
-VMMR3DECL(int)          SSMR3Cancel(PVM pVM);
+VMMR3DECL(int)          SSMR3Cancel(PUVM pUVM);
 
 
Index: trunk/include/VBox/vmm/stam.h
===================================================================
--- trunk/include/VBox/vmm/stam.h	(revision 44346)
+++ trunk/include/VBox/vmm/stam.h	(revision 44347)
@@ -1221,16 +1221,10 @@
     STAM_STATS({ STAM_REL_DEREG(pVM, pvSample); })
 
-VMMR3DECL(int)  STAMR3ResetU(PUVM pUVM, const char *pszPat);
-VMMR3DECL(int)  STAMR3Reset(PVM pVM, const char *pszPat);
-VMMR3DECL(int)  STAMR3SnapshotU(PUVM pUVM, const char *pszPat, char **ppszSnapshot, size_t *pcchSnapshot, bool fWithDesc);
-VMMR3DECL(int)  STAMR3Snapshot(PVM pVM, const char *pszPat, char **ppszSnapshot, size_t *pcchSnapshot, bool fWithDesc);
-VMMR3DECL(int)  STAMR3SnapshotFreeU(PUVM pUVM, char *pszSnapshot);
-VMMR3DECL(int)  STAMR3SnapshotFree(PVM pVM, char *pszSnapshot);
-VMMR3DECL(int)  STAMR3DumpU(PUVM pUVM, const char *pszPat);
-VMMR3DECL(int)  STAMR3Dump(PVM pVM, const char *pszPat);
-VMMR3DECL(int)  STAMR3DumpToReleaseLogU(PUVM pUVM, const char *pszPat);
-VMMR3DECL(int)  STAMR3DumpToReleaseLog(PVM pVM, const char *pszPat);
-VMMR3DECL(int)  STAMR3PrintU(PUVM pUVM, const char *pszPat);
-VMMR3DECL(int)  STAMR3Print(PVM pVM, const char *pszPat);
+VMMR3DECL(int)  STAMR3Reset(PUVM pUVM, const char *pszPat);
+VMMR3DECL(int)  STAMR3Snapshot(PUVM pUVM, const char *pszPat, char **ppszSnapshot, size_t *pcchSnapshot, bool fWithDesc);
+VMMR3DECL(int)  STAMR3SnapshotFree(PUVM pUVM, char *pszSnapshot);
+VMMR3DECL(int)  STAMR3Dump(PUVM pUVM, const char *pszPat);
+VMMR3DECL(int)  STAMR3DumpToReleaseLog(PUVM pUVM, const char *pszPat);
+VMMR3DECL(int)  STAMR3Print(PUVM pUVM, const char *pszPat);
 
 /**
@@ -1252,6 +1246,5 @@
 typedef FNSTAMR3ENUM *PFNSTAMR3ENUM;
 
-VMMR3DECL(int)  STAMR3EnumU(PUVM pUVM, const char *pszPat, PFNSTAMR3ENUM pfnEnum, void *pvUser);
-VMMR3DECL(int)  STAMR3Enum(PVM pVM, const char *pszPat, PFNSTAMR3ENUM pfnEnum, void *pvUser);
+VMMR3DECL(int)  STAMR3Enum(PUVM pUVM, const char *pszPat, PFNSTAMR3ENUM pfnEnum, void *pvUser);
 VMMR3DECL(const char *) STAMR3GetUnit(STAMUNIT enmUnit);
 